/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/beads/AxisBaseBead.as
 * org.apache.flex.charts.beads.AxisBaseBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.beads.AxisBaseBead');

goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.graphics.SolidColor');
goog.require('org.apache.flex.graphics.SolidColorStroke');
goog.require('org.apache.flex.svg.CompoundGraphic');
goog.require('org.apache.flex.charts.core.IAxisBead');
goog.require('org.apache.flex.utils.Language');



/**
 * Constructor.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @implements {org.apache.flex.charts.core.IAxisBead}
 */
org.apache.flex.charts.beads.AxisBaseBead = function() {
  var /** @type {org.apache.flex.graphics.SolidColorStroke} */ blackLine = new org.apache.flex.graphics.SolidColorStroke();
  blackLine.color = 0x111111;
  blackLine.weight = 1;
  blackLine.alpha = 1.0;
  this.axisStroke = blackLine;
  this.tickStroke = blackLine;
  var /** @type {org.apache.flex.graphics.SolidColor} */ blackFill = new org.apache.flex.graphics.SolidColor();
  blackFill.color = 0x111111;
  blackFill.alpha = 1.0;
  this.tickFill = blackFill;
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._strand;


/**
 * @private
 * @type {org.apache.flex.svg.CompoundGraphic}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.wrapper;


/**
 * @private
 * @type {org.apache.flex.charts.core.IAxisGroup}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._axisGroup;


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._placement = "unset";


/**
 * @private
 * @type {org.apache.flex.graphics.IStroke}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._axisStroke;


/**
 * @private
 * @type {org.apache.flex.graphics.IStroke}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._tickStroke;


/**
 * @private
 * @type {org.apache.flex.graphics.IFill}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype._tickFill;


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.tickPathString = null;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.tickMaxWidth = 0;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.tickMaxHeight = 0;


/**
 * Removes all graphic elements.
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @protected
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.clearGraphics = function() {
  this.axisGroup.removeAllElements();
};


/**
 * @asprivate
 * @protected
 * @param {number} originX
 * @param {number} originY
 * @param {number} xoffset
 * @param {number} yoffset
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.drawAxisPath = function(originX, originY, xoffset, yoffset) {
  this.axisGroup.drawAxisLine(originX, originY, xoffset, yoffset, this.axisStroke);
};


/**
 * @asprivate
 * @protected
 * @param {string} text
 * @param {number} xpos
 * @param {number} ypos
 * @param {number} boxWidth
 * @param {number} boxHeight
 * @return {Object}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.addTickLabel = function(text, xpos, ypos, boxWidth, boxHeight) {
  var /** @type {boolean} */ isHorizontal = (this.placement == "bottom") || (this.placement == "top");
  var /** @type {Object} */ label;
  if (isHorizontal)
    label = this.axisGroup.drawHorizontalTickLabel(text, xpos, ypos, boxWidth, boxHeight, this.tickFill);
  else
    label = this.axisGroup.drawVerticalTickLabel(text, xpos, ypos, boxWidth, boxHeight, this.tickFill);
  label.element.style.position = "absolute";
  return label;
};


/**
 * @asprivate
 * @protected
 * @param {number} xpos
 * @param {number} ypos
 * @param {number} xoffset
 * @param {number} yoffset
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.addTickMark = function(xpos, ypos, xoffset, yoffset) {
  if (this.tickPathString == null)
    this.tickPathString = "";
  this.tickPathString = this.tickPathString + " M " + String(xpos) + " " + String(ypos);
  this.tickPathString = this.tickPathString + " l " + String(xoffset) + " " + String(yoffset);
  this.tickMaxWidth = Math.max(this.tickMaxWidth, xpos + xoffset);
  this.tickMaxHeight = Math.max(this.tickMaxHeight, ypos + yoffset);
};


/**
 * @asprivate
 * @protected
 * @param {number} originX
 * @param {number} originY
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.drawTickPath = function(originX, originY) {
  this.axisGroup.drawTickMarks(originX, originY, this.tickMaxWidth, this.tickMaxHeight, this.tickPathString, this.tickStroke);
  this.tickPathString = null;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__placement = function() {
  return this._placement;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__placement = function(value) {
  this._placement = value;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__axisStroke = function() {
  return this._axisStroke;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__axisStroke = function(value) {
  this._axisStroke = value;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__tickStroke = function() {
  return this._tickStroke;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__tickStroke = function(value) {
  this._tickStroke = value;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__tickFill = function() {
  return this._tickFill;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__tickFill = function(value) {
  this._tickFill = value;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__axisGroup = function() {
  return this._axisGroup;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__axisGroup = function(value) {
  this._axisGroup = value;
  this.wrapper = new org.apache.flex.svg.CompoundGraphic();
  org.apache.flex.utils.Language.as(this._axisGroup, org.apache.flex.core.UIBase, true).addElement(this.wrapper);
  this.wrapper.x = 0;
  this.wrapper.y = 0;
  this.wrapper.width = org.apache.flex.utils.Language.as(this._axisGroup, org.apache.flex.core.UIBase, true).width;
  this.wrapper.height = org.apache.flex.utils.Language.as(this._axisGroup, org.apache.flex.core.UIBase, true).height;
  this.wrapper.element.style.position = "absolute";
  org.apache.flex.utils.Language.as(this._axisGroup, org.apache.flex.core.UIBase, true).element.style.position = "absolute";
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.get__strand = function() {
  return this._strand;
};


org.apache.flex.charts.beads.AxisBaseBead.prototype.set__strand = function(value) {
  this._strand = value;
};


Object.defineProperties(org.apache.flex.charts.beads.AxisBaseBead.prototype, /** @lends {org.apache.flex.charts.beads.AxisBaseBead.prototype} */ {
/** @export */
placement: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__placement,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__placement},
/** @export */
axisStroke: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__axisStroke,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__axisStroke},
/** @export */
tickStroke: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__tickStroke,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__tickStroke},
/** @export */
tickFill: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__tickFill,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__tickFill},
/** @export */
axisGroup: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__axisGroup,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__axisGroup},
/** @export */
strand: {
get: org.apache.flex.charts.beads.AxisBaseBead.prototype.get__strand,
set: org.apache.flex.charts.beads.AxisBaseBead.prototype.set__strand}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'AxisBaseBead', qName: 'org.apache.flex.charts.beads.AxisBaseBead', kind: 'class' }], interfaces: [org.apache.flex.charts.core.IAxisBead] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.beads.AxisBaseBead', org.apache.flex.charts.beads.AxisBaseBead);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.beads.AxisBaseBead.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'placement': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'},
        'axisStroke': { type: 'org.apache.flex.graphics.IStroke', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'},
        'tickStroke': { type: 'org.apache.flex.graphics.IStroke', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'},
        'tickFill': { type: 'org.apache.flex.graphics.IFill', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'},
        'axisGroup': { type: 'org.apache.flex.charts.core.IAxisGroup', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'},
        'strand': { type: 'org.apache.flex.core.IStrand', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'}
      };
    },
    methods: function () {
      return {
        'AxisBaseBead': { type: '', declaredBy: 'org.apache.flex.charts.beads.AxisBaseBead'}
      };
    }
  };
};