/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/beads/VerticalLinearAxisBead.as
 * org.apache.flex.charts.beads.VerticalLinearAxisBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.beads.VerticalLinearAxisBead');

goog.require('org.apache.flex.charts.beads.AxisBaseBead');
goog.require('org.apache.flex.charts.core.IChart');
goog.require('org.apache.flex.core.ISelectionModel');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.html.beads.models.ArraySelectionModel');
goog.require('org.apache.flex.charts.core.IVerticalAxisBead');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.charts.beads.AxisBaseBead}
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.charts.core.IVerticalAxisBead}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead = function() {
  
  this._maximum = Number.NaN;
  org.apache.flex.charts.beads.VerticalLinearAxisBead.base(this, 'constructor');
  this.placement = "left";
};
goog.inherits(org.apache.flex.charts.beads.VerticalLinearAxisBead, org.apache.flex.charts.beads.AxisBaseBead);


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype._strand;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype._axisWidth = 50;


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype._valueField;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype._minimum = 0;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype._maximum;


/**
 * @asprivate
 * @protected
 * @param {number} n
 * @return {string}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.formatLabel = function(n) {
  var /** @type {number} */ sign = n < 0 ? -1 : 1;
  n = Math.abs(n);
  var /** @type {number} */ i = 0;
  if (0 <= n && n <= 1) {
    i = Math.round(n * 100);
    n = i / 100.0;
  } else {
    i = Math.round(n);
    n = i;
  }
  var /** @type {string} */ result = String(sign * n);
  return result;
};


/**
 * @asprivate
 * @protected
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.handleItemsCreated = function(event) {
  var /** @type {org.apache.flex.html.beads.models.ArraySelectionModel} */ model = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ISelectionModel), org.apache.flex.html.beads.models.ArraySelectionModel);
  var /** @type {Array} */ items;
  if (org.apache.flex.utils.Language.is(model.dataProvider, Array))
    items = org.apache.flex.utils.Language.as(model.dataProvider, Array);
  else
    return;
  this.clearGraphics();
  var /** @type {Array} */ series = org.apache.flex.utils.Language.as(this.strand, org.apache.flex.charts.core.IChart, true).series;
  var /** @type {number} */ useHeight = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).height;
  var /** @type {number} */ useWidth = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).width;
  var /** @type {number} */ xpos = 0;
  var /** @type {number} */ ypos = useHeight;
  var /** @type {number} */ minValue = Number.MAX_VALUE;
  var /** @type {number} */ maxValue = Number.MIN_VALUE;
  if (isNaN(this.minimum)) {
    for (var /** @type {number} */ i = 0; i < items.length; i++) {
      var /** @type {number} */ value = Number(items[i][this.valueField]);
      if (!isNaN(value))
        minValue = Math.min(minValue, value);
      else
        minValue = Math.min(minValue, 0);
    }
  } else {
    minValue = this.minimum;
  }
  if (isNaN(this.maximum)) {
    for (i = 0; i < items.length; i++) {
      value = Number(items[i][this.valueField]);
      if (!isNaN(value))
        maxValue = Math.max(maxValue, value);
      else
        maxValue = Math.max(maxValue, 0);
    }
  } else {
    maxValue = this.maximum;
  }
  var /** @type {number} */ range = maxValue - minValue;
  var /** @type {number} */ numTicks = 10;
  var /** @type {number} */ tickStep = range / numTicks;
  var /** @type {number} */ tickSpacing = useHeight / numTicks;
  var /** @type {number} */ tickValue = this.minimum;
  var /** @type {number} */ labelY = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).height + 8;
  for (i = 0; i < numTicks + 1; i++) {
    var /** @type {Object} */ label = this.addTickLabel(this.formatLabel(tickValue), 0, ypos, 0, tickSpacing);
    label.y = ypos - label.height / 2;
    this.addTickMark(useWidth - 6, ypos, 5, 0);
    ypos -= tickSpacing;
    tickValue += tickStep;
  }
  this.drawAxisPath(useWidth - 1, 0, 0, useHeight);
  this.drawTickPath(useWidth - 6, 0);
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__strand = function() {
  return this._strand;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__strand = function(value) {
  this._strand = value;
  org.apache.flex.charts.beads.VerticalLinearAxisBead.superClass_.set__strand.apply(this, [ value] );
  org.apache.flex.utils.Language.as(this.strand, org.apache.flex.events.IEventDispatcher, true).addEventListener("layoutComplete", org.apache.flex.utils.Language.closure(this.handleItemsCreated, this, 'handleItemsCreated'));
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__axisWidth = function() {
  return this._axisWidth;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__axisWidth = function(value) {
  this._axisWidth = value;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__valueField = function() {
  return this._valueField;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__valueField = function(value) {
  this._valueField = value;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__minimum = function() {
  return this._minimum;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__minimum = function(value) {
  this._minimum = value;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__maximum = function() {
  return this._maximum;
};


org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__maximum = function(value) {
  this._maximum = value;
};


Object.defineProperties(org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype, /** @lends {org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype} */ {
/** @export */
strand: {
get: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__strand,
set: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__strand},
/** @export */
axisWidth: {
get: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__axisWidth,
set: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__axisWidth},
/** @export */
valueField: {
get: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__valueField,
set: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__valueField},
/** @export */
minimum: {
get: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__minimum,
set: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__minimum},
/** @export */
maximum: {
get: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.get__maximum,
set: org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.set__maximum}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'VerticalLinearAxisBead', qName: 'org.apache.flex.charts.beads.VerticalLinearAxisBead', kind: 'class' }], interfaces: [org.apache.flex.core.IBead, org.apache.flex.charts.core.IVerticalAxisBead] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.beads.VerticalLinearAxisBead', org.apache.flex.charts.beads.VerticalLinearAxisBead);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.beads.VerticalLinearAxisBead.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'strand': { type: 'org.apache.flex.core.IStrand', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'},
        'axisWidth': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'},
        'valueField': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'},
        'minimum': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'},
        'maximum': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'}
      };
    },
    methods: function () {
      return {
        'VerticalLinearAxisBead': { type: '', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisBead'}
      };
    }
  };
};