/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/beads/VerticalLinearAxisForArrayListBead.as
 * org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead');

goog.require('org.apache.flex.charts.beads.VerticalLinearAxisBead');
goog.require('org.apache.flex.charts.core.IChart');
goog.require('org.apache.flex.collections.ArrayList');
goog.require('org.apache.flex.core.ISelectionModel');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.html.beads.models.ArrayListSelectionModel');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.charts.beads.VerticalLinearAxisBead}
 */
org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead = function() {
  org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead, org.apache.flex.charts.beads.VerticalLinearAxisBead);


/**
 * @asprivate
 * @protected
 * @override
 */
org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead.prototype.handleItemsCreated = function(event) {
  var /** @type {org.apache.flex.html.beads.models.ArrayListSelectionModel} */ model = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ISelectionModel), org.apache.flex.html.beads.models.ArrayListSelectionModel);
  var /** @type {org.apache.flex.collections.ArrayList} */ items;
  if (org.apache.flex.utils.Language.is(model.dataProvider, org.apache.flex.collections.ArrayList))
    items = org.apache.flex.utils.Language.as(model.dataProvider, org.apache.flex.collections.ArrayList);
  else
    return;
  this.clearGraphics();
  var /** @type {Array} */ series = org.apache.flex.utils.Language.as(this.strand, org.apache.flex.charts.core.IChart, true).series;
  var /** @type {number} */ useHeight = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).height;
  var /** @type {number} */ useWidth = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).width;
  var /** @type {number} */ xpos = 0;
  var /** @type {number} */ ypos = useHeight;
  var /** @type {number} */ minValue = Number.MAX_VALUE;
  var /** @type {number} */ maxValue = Number.MIN_VALUE;
  if (isNaN(this.minimum)) {
    for (var /** @type {number} */ i = 0; i < items.length; i++) {
      var /** @type {Object} */ item = items.getItemAt(i);
      var /** @type {number} */ value = Number(item[this.valueField]);
      if (!isNaN(value))
        minValue = Math.min(minValue, value);
      else
        minValue = Math.min(minValue, 0);
    }
  } else {
    minValue = this.minimum;
  }
  if (isNaN(this.maximum)) {
    for (i = 0; i < items.length; i++) {
      item = items.getItemAt(i);
      value = Number(item[this.valueField]);
      if (!isNaN(value))
        maxValue = Math.max(maxValue, value);
      else
        maxValue = Math.max(maxValue, 0);
    }
  } else {
    maxValue = this.maximum;
  }
  var /** @type {number} */ range = maxValue - minValue;
  var /** @type {number} */ numTicks = 10;
  var /** @type {number} */ tickStep = range / numTicks;
  var /** @type {number} */ tickSpacing = useHeight / numTicks;
  var /** @type {number} */ tickValue = this.minimum;
  var /** @type {number} */ labelY = org.apache.flex.utils.Language.as(this.axisGroup, org.apache.flex.core.UIBase, true).height + 8;
  for (i = 0; i < numTicks + 1; i++) {
    var /** @type {Object} */ label = this.addTickLabel(this.formatLabel(tickValue), 0, ypos, 0, tickSpacing);
    label.y = ypos - label.height / 2;
    this.addTickMark(useWidth - 6, ypos, 5, 0);
    ypos -= tickSpacing;
    tickValue += tickStep;
  }
  this.drawAxisPath(useWidth - 1, 0, 0, useHeight);
  this.drawTickPath(useWidth - 6, 0);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'VerticalLinearAxisForArrayListBead', qName: 'org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead', kind: 'class' }] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead', org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'VerticalLinearAxisForArrayListBead': { type: '', declaredBy: 'org.apache.flex.charts.beads.VerticalLinearAxisForArrayListBead'}
      };
    }
  };
};