/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/beads/layouts/LineChartCategoryVsLinearLayout.as
 * org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout');

goog.require('org.apache.flex.charts.beads.layouts.ChartBaseLayout');
goog.require('org.apache.flex.charts.core.IChartSeries');
goog.require('org.apache.flex.charts.supportClasses.ILineSegmentItemRenderer');
goog.require('org.apache.flex.charts.supportClasses.LineSeries');
goog.require('org.apache.flex.core.ILayoutHost');
goog.require('org.apache.flex.core.IParentIUIBase');
goog.require('org.apache.flex.core.ISelectionModel');
goog.require('org.apache.flex.charts.core.ICartesianChartLayout');
goog.require('org.apache.flex.core.IBeadLayout');
goog.require('org.apache.flex.utils.Language');



/**
 * @constructor
 * @extends {org.apache.flex.charts.beads.layouts.ChartBaseLayout}
 * @implements {org.apache.flex.core.IBeadLayout}
 * @implements {org.apache.flex.charts.core.ICartesianChartLayout}
 */
org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout = function() {
  org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout, org.apache.flex.charts.beads.layouts.ChartBaseLayout);


/**
 * @asprivate
 * @export
 * @override
 */
org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout.prototype.layout = function() {
  var /** @type {org.apache.flex.core.ISelectionModel} */ selectionModel = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ISelectionModel), org.apache.flex.core.ISelectionModel);
  var /** @type {Array} */ dp = org.apache.flex.utils.Language.as(selectionModel.dataProvider, Array);
  if (!dp)
    return false;
  var /** @type {org.apache.flex.core.ILayoutHost} */ layoutParent = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ILayoutHost), org.apache.flex.core.ILayoutHost);
  var /** @type {org.apache.flex.core.IParentIUIBase} */ contentView = org.apache.flex.utils.Language.as(layoutParent.contentView, org.apache.flex.core.IParentIUIBase);
  var /** @type {number} */ n = dp.length;
  var /** @type {number} */ xAxisOffset = 0;
  var /** @type {number} */ yAxisOffset = 0;
  var /** @type {number} */ xpos = yAxisOffset;
  var /** @type {number} */ useWidth = contentView.width - yAxisOffset;
  var /** @type {number} */ useHeight = contentView.height - xAxisOffset;
  var /** @type {number} */ itemWidth = useWidth / dp.length;
  var /** @type {number} */ maxYValue = 0;
  var /** @type {number} */ minYValue = 0;
  var /** @type {number} */ scaleYFactor = 1;
  var /** @type {boolean} */ determineYScale = true;
  var /** @type {Array} */ seriesPoints = [];
  if (this.verticalAxisBead != null && !isNaN(this.verticalAxisBead.maximum)) {
    maxYValue = this.verticalAxisBead.maximum;
    determineYScale = false;
  }
  if (this.verticalAxisBead != null && !isNaN(this.verticalAxisBead.minimum)) {
    minYValue = this.verticalAxisBead.minimum;
  }
  for (var /** @type {number} */ s = 0; s < this.chart.series.length; s++) {
    var /** @type {org.apache.flex.charts.core.IChartSeries} */ aseries = org.apache.flex.utils.Language.as(this.chart.series[s], org.apache.flex.charts.core.IChartSeries);
    seriesPoints.push({points:[]});
    for (var /** @type {number} */ i = 0; i < n; i++) {
      var /** @type {Object} */ data = dp[i];
      var /** @type {string} */ field = aseries.yField;
      var /** @type {number} */ yValue = Number(data[field]);
      if (determineYScale)
        maxYValue = Math.max(maxYValue, yValue);
    }
  }
  scaleYFactor = useHeight / (maxYValue - minYValue);
  for (s = 0; s < this.chart.series.length; s++) {
    aseries = org.apache.flex.utils.Language.as(this.chart.series[s], org.apache.flex.charts.core.IChartSeries);
    xpos = yAxisOffset + itemWidth / 2;
    for (i = 0; i < n; i++) {
      data = dp[i];
      yValue = Number(data[aseries.yField]) - minYValue;
      var /** @type {number} */ childX = xpos;
      var /** @type {number} */ childY = useHeight - yValue * scaleYFactor;
      seriesPoints[s].points.push({x:childX, y:childY});
      var /** @type {org.apache.flex.charts.core.IChartItemRenderer} */ child = this.chartDataGroup.getItemRendererForSeriesAtIndex(aseries, i);
      if (child) {
        child.x = childX - 5;
        child.y = childY - 5;
        child.width = 10;
        child.height = 10;
        child.element.style.position = "absolute";
      }
      xpos += itemWidth;
    }
  }
  for (s = 0; s < this.chart.series.length; s++) {
    var /** @type {org.apache.flex.charts.supportClasses.LineSeries} */ lcs = org.apache.flex.utils.Language.as(this.chart.series[s], org.apache.flex.charts.supportClasses.LineSeries);
    if (lcs.lineSegmentRenderer) {
      var /** @type {org.apache.flex.charts.supportClasses.ILineSegmentItemRenderer} */ renderer = org.apache.flex.utils.Language.as(lcs.lineSegmentRenderer.newInstance(), org.apache.flex.charts.supportClasses.ILineSegmentItemRenderer);
      this.chartDataGroup.addElement(renderer);
      renderer.itemRendererParent = this.chartDataGroup;
      renderer.data = lcs;
      renderer.points = seriesPoints[s].points;
    }
  }
  return true;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'LineChartCategoryVsLinearLayout', qName: 'org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout', kind: 'class' }], interfaces: [org.apache.flex.core.IBeadLayout, org.apache.flex.charts.core.ICartesianChartLayout] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout', org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {return {};},
    methods: function () {
      return {
        'LineChartCategoryVsLinearLayout': { type: '', declaredBy: 'org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout'},
        'layout': { type: 'Boolean', declaredBy: 'org.apache.flex.charts.beads.layouts.LineChartCategoryVsLinearLayout'}
      };
    }
  };
};