/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/beads/layouts/StackedBarChartLayout.as
 * org.apache.flex.charts.beads.layouts.StackedBarChartLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.beads.layouts.StackedBarChartLayout');

goog.require('org.apache.flex.charts.beads.layouts.ChartBaseLayout');
goog.require('org.apache.flex.charts.supportClasses.BarSeries');
goog.require('org.apache.flex.core.ILayoutHost');
goog.require('org.apache.flex.core.IParentIUIBase');
goog.require('org.apache.flex.core.ISelectionModel');
goog.require('org.apache.flex.charts.core.ICartesianChartLayout');
goog.require('org.apache.flex.core.IBeadLayout');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor
 *  
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.charts.beads.layouts.ChartBaseLayout}
 * @implements {org.apache.flex.core.IBeadLayout}
 * @implements {org.apache.flex.charts.core.ICartesianChartLayout}
 */
org.apache.flex.charts.beads.layouts.StackedBarChartLayout = function() {
  org.apache.flex.charts.beads.layouts.StackedBarChartLayout.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.beads.layouts.StackedBarChartLayout, org.apache.flex.charts.beads.layouts.ChartBaseLayout);


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype._gap = 20;


/**
 * @asprivate
 * @export
 * @override
 */
org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.layout = function() {
  var /** @type {org.apache.flex.core.ISelectionModel} */ selectionModel = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ISelectionModel), org.apache.flex.core.ISelectionModel);
  var /** @type {Array} */ dp = org.apache.flex.utils.Language.as(selectionModel.dataProvider, Array);
  if (!dp)
    return false;
  var /** @type {org.apache.flex.core.ILayoutHost} */ layoutParent = org.apache.flex.utils.Language.as(this.strand.getBeadByType(org.apache.flex.core.ILayoutHost), org.apache.flex.core.ILayoutHost);
  var /** @type {org.apache.flex.core.IParentIUIBase} */ contentView = org.apache.flex.utils.Language.as(layoutParent.contentView, org.apache.flex.core.IParentIUIBase);
  var /** @type {number} */ n = dp.length;
  var /** @type {number} */ maxXValue = 0;
  var /** @type {number} */ minXValue = 0;
  var /** @type {boolean} */ determineScale = true;
  var /** @type {Array} */ seriesMaxes = [];
  var /** @type {number} */ useWidth = contentView.width;
  var /** @type {number} */ useHeight = contentView.height;
  var /** @type {number} */ itemHeight = (useHeight - this.gap * (dp.length - 1)) / n;
  var /** @type {number} */ seriesHeight = itemHeight;
  var /** @type {number} */ xpos = 0;
  var /** @type {number} */ ypos = useHeight;
  var /** @type {Array} */ barValues = [];
  var /** @type {number} */ scaleFactor = 1;
  if (this.horizontalAxisBead != null && !isNaN(this.horizontalAxisBead.maximum)) {
    maxXValue = this.horizontalAxisBead.maximum;
    determineScale = false;
  }
  if (this.horizontalAxisBead != null && !isNaN(this.horizontalAxisBead.minimum)) {
    minXValue = this.horizontalAxisBead.minimum;
  }
  for (var /** @type {number} */ i = 0; i < n; i++) {
    barValues.push({totalValue:0, scaleFactor:0});
    var /** @type {Object} */ data = dp[i];
    for (var /** @type {number} */ s = 0; s < this.chart.series.length; s++) {
      var /** @type {org.apache.flex.charts.supportClasses.BarSeries} */ bcs = org.apache.flex.utils.Language.as(this.chart.series[s], org.apache.flex.charts.supportClasses.BarSeries);
      var /** @type {string} */ field = bcs.xField;
      var /** @type {number} */ xValue = Number(data[field]);
      barValues[i].totalValue += xValue;
    }
    if (determineScale) {
      maxXValue = Math.max(maxXValue, barValues[i].totalValue);
    }
  }
  scaleFactor = useWidth / (maxXValue - minXValue);
  for (i = 0; i < n; i++) {
    data = dp[i];
    xpos = 0;
    for (s = 0; s < this.chart.series.length; s++) {
      bcs = org.apache.flex.utils.Language.as(this.chart.series[s], org.apache.flex.charts.supportClasses.BarSeries);
      var /** @type {org.apache.flex.charts.core.IChartItemRenderer} */ child = this.chartDataGroup.getItemRendererForSeriesAtIndex(bcs, i);
      xValue = Number(data[bcs.xField]) - minXValue;
      xValue = xValue * scaleFactor;
      child.x = xpos;
      child.width = Math.floor(xValue);
      child.y = Math.floor(ypos - seriesHeight);
      child.height = seriesHeight;
      child.element.style.position = "absolute";
      xpos += xValue;
    }
    ypos -= (itemHeight + this.gap);
  }
  return true;
};


org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.get__gap = function() {
  return this._gap;
};


org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.set__gap = function(value) {
  this._gap = value;
};


Object.defineProperties(org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype, /** @lends {org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype} */ {
/** @export */
gap: {
get: org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.get__gap,
set: org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.set__gap}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'StackedBarChartLayout', qName: 'org.apache.flex.charts.beads.layouts.StackedBarChartLayout', kind: 'class' }], interfaces: [org.apache.flex.core.IBeadLayout, org.apache.flex.charts.core.ICartesianChartLayout] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.beads.layouts.StackedBarChartLayout', org.apache.flex.charts.beads.layouts.StackedBarChartLayout);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.beads.layouts.StackedBarChartLayout.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'gap': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.beads.layouts.StackedBarChartLayout'}
      };
    },
    methods: function () {
      return {
        'StackedBarChartLayout': { type: '', declaredBy: 'org.apache.flex.charts.beads.layouts.StackedBarChartLayout'},
        'layout': { type: 'Boolean', declaredBy: 'org.apache.flex.charts.beads.layouts.StackedBarChartLayout'}
      };
    }
  };
};