/**
 * Generated by Apache Flex Cross-Compiler from org/apache/flex/charts/optimized/SVGWedgeItemRenderer.as
 * org.apache.flex.charts.optimized.SVGWedgeItemRenderer
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.flex.charts.optimized.SVGWedgeItemRenderer');

goog.require('org.apache.flex.html.supportClasses.DataItemRenderer');
goog.require('org.apache.flex.svg.CompoundGraphic');
goog.require('org.apache.flex.charts.supportClasses.IWedgeItemRenderer');
goog.require('org.apache.flex.utils.Language');



/**
 *  constructor.
 *
 *  @langversion 3.0
 *  @playerversion Flash 10.2
 *  @playerversion AIR 2.6
 *  @productversion FlexJS 0.0
 * @constructor
 * @extends {org.apache.flex.html.supportClasses.DataItemRenderer}
 * @implements {org.apache.flex.charts.supportClasses.IWedgeItemRenderer}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer = function() {
  org.apache.flex.charts.optimized.SVGWedgeItemRenderer.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.optimized.SVGWedgeItemRenderer, org.apache.flex.html.supportClasses.DataItemRenderer);


/**
 * @private
 * @type {org.apache.flex.charts.core.IChartSeries}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._series;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._centerX;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._centerY;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._startAngle;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._arc;


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._radius;


/**
 * @private
 * @type {org.apache.flex.graphics.IFill}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._fill;


/**
 * @private
 * @type {org.apache.flex.graphics.IStroke}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype._stroke;


/**
 * @asprivate
 * @private
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.drawWedgeInternal = function() {
  if (!isNaN(this.centerX) && !isNaN(this.centerY) && !isNaN(this.startAngle) && !isNaN(this.arc) && !isNaN(this.radius)) {
    this.drawWedge(this.centerX, this.centerY, this.startAngle, this.arc, this.radius, this.radius, false);
  }
};


/**
 * @asprivate
 * 
 * Draw a wedge of a circle
 * @asparam graphics      the graphics object to draw into
 * @asparam x             the x center of the circle
 * @asparam y             the y center of the circle
 * @asparam startAngle    start angle (radians)
 * @asparam arc           sweep angle (radians)
 * @asparam radius        radius of the circle
 * @asparam yRadius       vertical radius (or radius if none given)
 * @asparam continueFlag  if true, uses a moveTo call to start drawing at the start point of the circle; else continues drawing using only lineTo and curveTo
 * 
 * @export
 * @param {number} x
 * @param {number} y
 * @param {number} startAngle
 * @param {number} arc
 * @param {number} radius
 * @param {number=} yRadius
 * @param {boolean=} continueFlag
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.drawWedge = function(x, y, startAngle, arc, radius, yRadius, continueFlag) {
  yRadius = typeof yRadius !== 'undefined' ? yRadius : NaN;
  continueFlag = typeof continueFlag !== 'undefined' ? continueFlag : false;
  var /** @type {org.apache.flex.svg.CompoundGraphic} */ graphicsContainer = org.apache.flex.utils.Language.as(this.itemRendererParent, org.apache.flex.svg.CompoundGraphic);
  var /** @type {number} */ x1 = x + radius * Math.cos(startAngle);
  var /** @type {number} */ y1 = y + radius * Math.sin(startAngle);
  var /** @type {number} */ x2 = x + radius * Math.cos(startAngle + arc);
  var /** @type {number} */ y2 = y + radius * Math.sin(startAngle + arc);
  var /** @type {string} */ pathString = 'M' + x + ' ' + y + ' L' + x1 + ' ' + y1 + ' A' + radius + ' ' + radius + ' 0 0 1 ' + x2 + ' ' + y2 + ' z';
  graphicsContainer.fill = this.fill;
  graphicsContainer.stroke = this.stroke;
  graphicsContainer.drawStringPath(pathString);
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__series = function() {
  return this._series;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__series = function(value) {
  this._series = value;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__centerX = function() {
  return this._centerX;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__centerX = function(value) {
  this._centerX = value;
  this.drawWedgeInternal();
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__centerY = function() {
  return this._centerY;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__centerY = function(value) {
  this._centerY = value;
  this.drawWedgeInternal();
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__startAngle = function() {
  return this._startAngle;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__startAngle = function(value) {
  this._startAngle = value;
  this.drawWedgeInternal();
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__arc = function() {
  return this._arc;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__arc = function(value) {
  this._arc = value;
  this.drawWedgeInternal();
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__radius = function() {
  return this._radius;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__radius = function(value) {
  this._radius = value;
  this.drawWedgeInternal();
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__fill = function() {
  return this._fill;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__fill = function(value) {
  this._fill = value;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__stroke = function() {
  return this._stroke;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__stroke = function(value) {
  this._stroke = value;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__xField = function() {
  return null;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__xField = function(value) {
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__yField = function() {
  return null;
};


org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__yField = function(value) {
};


Object.defineProperties(org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype, /** @lends {org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype} */ {
/** @export */
series: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__series,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__series},
/** @export */
centerX: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__centerX,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__centerX},
/** @export */
centerY: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__centerY,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__centerY},
/** @export */
startAngle: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__startAngle,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__startAngle},
/** @export */
arc: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__arc,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__arc},
/** @export */
radius: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__radius,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__radius},
/** @export */
fill: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__fill,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__fill},
/** @export */
stroke: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__stroke,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__stroke},
/** @export */
xField: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__xField,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__xField},
/** @export */
yField: {
get: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.get__yField,
set: org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.set__yField}}
);


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'SVGWedgeItemRenderer', qName: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer', kind: 'class' }], interfaces: [org.apache.flex.charts.supportClasses.IWedgeItemRenderer] };


/**
 * Prevent renaming of class. Needed for reflection.
 */
goog.exportSymbol('org.apache.flex.charts.optimized.SVGWedgeItemRenderer', org.apache.flex.charts.optimized.SVGWedgeItemRenderer);



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.flex.charts.optimized.SVGWedgeItemRenderer.prototype.FLEXJS_REFLECTION_INFO = function () {
  return {
    variables: function () {return {};},
    accessors: function () {
      return {
        'series': { type: 'org.apache.flex.charts.core.IChartSeries', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'centerX': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'centerY': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'startAngle': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'arc': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'radius': { type: 'Number', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'fill': { type: 'org.apache.flex.graphics.IFill', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'stroke': { type: 'org.apache.flex.graphics.IStroke', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'xField': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'yField': { type: 'String', access: 'readwrite', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'}
      };
    },
    methods: function () {
      return {
        'SVGWedgeItemRenderer': { type: '', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer'},
        'drawWedge': { type: 'void', declaredBy: 'org.apache.flex.charts.optimized.SVGWedgeItemRenderer', parameters: function () { return [  { index: 1, type: 'Number', optional: false },{ index: 2, type: 'Number', optional: false },{ index: 3, type: 'Number', optional: false },{ index: 4, type: 'Number', optional: false },{ index: 5, type: 'Number', optional: false },{ index: 6, type: 'Number', optional: true },{ index: 7, type: 'Boolean', optional: true } ]; }}
      };
    }
  };
};